rgw: s3 v4 auth fails during chunked file uploads when object size = 0
Status: New Start date: 08/15/2017

Priority: Normal Due date:  

Assignee: Marcus Watts % Done: 0%

Category:  Estimated time: 0.00 hour

Target version:  Spent time: 0.00 hour

Source:  Reviewed:  

Tags:  Affected Versions:  

Backport:  ceph-qa-suite:  

Regression: No Pull request ID:  

Severity: 3 - minor   

Description

Chunked file transfers of object size 0 fail.  Chunked file transfers of larger objects work fine.

In the logs (with a suitable rgw debug level), this message appears when signature verification happens,

NOTICE: call to do_aws4_auth_completion

On successful verifications, this message appears just before,

parsed new chunk; signature=0b32543586406d29be2

a36c61ca83bb13559f0526d0181e0aedb444ceb6dc4ca, data_length=2048, data_starts_in_stream=86

(numbers may vary).  On the failing transfers, this message does not appear.

This is possibly only an aws4 issue.  It definitely breaks many hadoop tests.

History

#1 - 08/15/2017 07:45 PM - Marcus Watts

- Assignee set to Marcus Watts

#2 - 08/15/2017 07:46 PM - Marcus Watts

I have a possible fix for this, but it's failing on "16 byte" objects - which I think is a different problem also reported in 

http://tracker.ceph.com/issues/21003

#3 - 08/16/2017 02:25 AM - Marcus Watts

I have a possible fix for this problem in:

https://github.com/ceph/ceph/pull/17040

This also contains a fix for small sized chunks, and a "space/plus" fix.
